local SecondaryMenuWindow = {}

local _log = commonapi.utils.logPrep("commonapi2.ui.SecondaryMenuWindow")
local _utils = commonapi.utils
local global_ = _
--local _ = _utils._t

package.loaded["commonapi2.ui2.tpfui"] = nil
local ui = require("commonapi2.ui2.tpfui")

if (ui.Popup.isSupported()) then
	SecondaryMenuWindow = ui.Popup:new()
else
	SecondaryMenuWindow = ui.Window:new()
end
SecondaryMenuWindow.id =  "SecondaryMenuWindow"
SecondaryMenuWindow.caption = ""
SecondaryMenuWindow.uilist = {}

SecondaryMenuWindow.height = 500
SecondaryMenuWindow.width = 500
SecondaryMenuWindow.popupDirection = 4


function SecondaryMenuWindow.create()
	local o
	o = SecondaryMenuWindow:new()
	o:createUIList()
	if (o.isPopup == true) then
		local cbuttonParent = api.gui.util.getById("mainMenuLeft.CommonAPI2Button.button")
		o:open(cbuttonParent)
		return o
	end
	o:open()
	local cbutton = api.gui.util.getById("mainMenuLeft.CommonAPI2Button.button")

	if (cbutton ~= nil) then
		local cbuttonRect = cbutton:getContentRect()
		local rect = o:getPositionSize()
		o:setPosition(cbuttonRect.x, (cbuttonRect.y-rect.h) )
	end
	return o
end

function SecondaryMenuWindow:refresh()
	self:createUIList()
	self:rebuild()
end

function SecondaryMenuWindow:createUIList()
	local uilist = {}

	uilist[#uilist+1] = {
		typ = "Button",
		id = "Settings",
		caption = self._("Settings"),
		onclick = function(item, win)
			win:showSettings()
			win:close()
		end,
		gravity = { -1, 0 }
	}

	uilist[#uilist+1] = {
		typ = "Separator"
	}
	uilist[#uilist+1] = {
		typ = "Button",
		id = "Inspector",
		caption = self._("Inspector"),
		onclick = function(item, win)
			win:showInspector()
			win:close()
		end,
		gravity = { -1, 0 }
	}
	uilist[#uilist+1] = {
		typ = "Separator"
	}
	if (api.commonapiResRW ~= nil) then
		uilist[#uilist+1] = {
			typ = "Button",
			id = "trackStreetToolbox",
			caption = self._("Track & Street Toolbox"),
			onclick = function(item, win)
				win:showTrackStreetToolbox()
				win:close()
			end,
			gravity = { -1, 0 }
		}
	end

--[[
	if (commonapi._native ~= nil and commonapi._native.LayerView and commonapi._native.LayerView.isEnabled()) then
		local uilistLayerViewSettings = {}
		uilist[#uilist+1] = {
			typ = "LayoutHorizontal",
			uilist = uilistLayerViewSettings
		}

		uilistLayerViewSettings[#uilistLayerViewSettings+1] = {
			typ = "Checkbox",
			id = "layerViewAtManager",
			default = not commonapi._native.LayerView.getManagerDisable(),
			caption = self._("Auto white layer"),
			onclick = function(item, win)
				commonapi._native.LayerView.setManagerDisable( not (win.params[item.id] or false ) )
				win:refresh()
			end
		}

		uilistLayerViewSettings[#uilistLayerViewSettings+1] = {
			typ = "Button",
			id = "layerViewSetLayer2on",
			caption = self._("On"),
			onclick = function(item, win)
				commonapi._native.LayerView.setLayer(2, 1)
			end
		}

		uilistLayerViewSettings[#uilistLayerViewSettings+1] = {
			typ = "Button",
			id = "layerViewSetLayer2off",
			caption = self._("Off"),
			onclick = function(item, win)
				commonapi._native.LayerView.setLayer(2, 0)
			end
		}
	end
--]]

--[[
	uilist[#uilist+1] = {
		typ = "Button",
		id = "ReloadLineDestUI",
		caption = self._("Reload Line Destination UI Code"),
		onclick = function(item, win)
			win:reloadLineDestUI()
			win:close()
		end
	}
--]]
	self.uilist = uilist
end

function SecondaryMenuWindow.showSettings()
	package.loaded["commonapi2.uicommon.ModSettingsWindow"] = nil
	--package.loaded["commonapi2.uicommon.interface"] = nil
	package.loaded["commonapi2.ui2.tpfui"] = nil
	commonapi._reloadModule("ui")
	_log("Reloading tpfui")
	local ModSettingsWindowTPF = require("commonapi2.uicommon.ModSettingsWindow")
	ModSettingsWindowTPF.createForCommonAPI()
end

function SecondaryMenuWindow.showInspector()
	package.loaded["commonapi2.ui2.tpfui"] = nil
	package.loaded["commonapi2.ui2.inspect"] = nil
	local inspector = require("commonapi2.ui2.inspect")
	inspector.create()
end

function SecondaryMenuWindow.showTrackStreetToolbox()
	package.loaded["commonapi2.ui2.trackStreetToolbox"] = nil
	local toolbox = require("commonapi2.ui2.trackStreetToolbox")
	toolbox.create()
end

function SecondaryMenuWindow.reloadLineDestUI()
	package.loaded["commonapi2.ui2.tpfui"] = nil
	package.loaded["commonapi2.ui2.LineDestination"] = nil
	local LineDestinationUI = require("commonapi2.ui2.LineDestination")
end

return SecondaryMenuWindow