--local gui = require "gui"
local secondaryui = {
	isInit = false,
	openCommonAPI2Button = false,
	traceGUICallback = nil,
	lastEntitySelected = nil,
	changeGUICallback = nil
}

function secondaryui.init()
	secondaryui.isInit = true

	local tga = "ui/commonapi2button@2x.tga"
	local capibuttonIcon = api.gui.comp.ImageView.new(tga)
	capibuttonIcon:setId("mainMenuLeft.CommonAPI2Button.button.icon")
	local capibutton = api.gui.comp.Button.new(capibuttonIcon, true)
	capibutton:setId("mainMenuLeft.CommonAPI2Button.button")
	capibutton:setGravity(0, 0.5)
	local mainMenuLeftLayout = api.gui.util.getById("mainMenuLeftLayout")

	mainMenuLeftLayout:insertItem(capibutton, 1)

	capibutton:onClick(function()
		local ok, err = pcall(secondaryui.openMenu)
		if (ok == false) then
			commonapi.dmp(err)
		end
	end)
	secondaryui.openCommonAPI2Button = capibutton

	if (commonapi._native ~= nil) then
		-- Install LineDestination Hooks
		if (commonapi._native.LabelSystem ~= nil and commonapi._native.LabelSystem.isEnabled()) then
			local LineDestination = require("commonapi2.ui2.LineDestination")
			print("Calling LineDestination:installHooks")
			LineDestination:installHooks()
		end

		if (commonapi._native.LayerView ~= nil and commonapi._native.LayerView.isEnabled()) then
			local LayerView = require("commonapi2.ui2.LayerView")
			LayerView:init()
		end

		if (commonapi._info.settings.improveui ~= nil) then
			if (commonapi._info.settings.improveui > 0) then
				local constructionlist = require("commonapi2.ui2.constructionlist")
				constructionlist.init()
			end
		end
	end
end


function secondaryui.layerviewdisable()
	commonapi._native.LayerView.setLayer(2, 1)
	commonapi._native.LayerView.setLayer(2, 0)
end

function secondaryui.layerview()
	if (commonapi._native ~= nil and commonapi._native.LayerView and commonapi._native.LayerView.isEnabled()) then

		local speedLimitWindow
		local speedLimitWindowContent
		local speedLimitWindowLayout
		local speedLimitWindowLayoutTop
		local wButtonId = "commonapi2.menulayers.speedLimitsWindowButton"
		local wButton = api.gui.util.getById(wButtonId)

		if (wButton == nil) then
			speedLimitWindow = api.gui.util.getById("menu.layers.speedLimitsWindow")
			--speedLimitWindowContent = speedLimitWindow:getContent()
			--speedLimitWindowLayout = speedLimitWindowContent:getLayout()

			speedLimitWindowLayoutTop = speedLimitWindow:getLayout():getItem(0):getLayout()

			local tga = "ui/icons/windows/vehicle_color@2x.tga"
			local wButtonIcon = api.gui.comp.ImageView.new(tga)
			wButton = api.gui.comp.Button.new(wButtonIcon, true)
			wButton:setId(wButtonId)
			wButton:setGravity(0, 0.5)

			--local lastItem = speedLimitWindowLayoutTop:getItem(speedLimitWindowLayoutTop:getNumItems()-1)
			--local c = lastItem:getContentRect()
			wButton:setMaximumSize( api.gui.util.Size.new(32, 32))

			wButton:setTooltip(_("Disable white layer").." (CommonAPI 2)")
			wButton:onClick(secondaryui.layerviewdisable)
			speedLimitWindowLayoutTop:addItem(wButton)
		end
	end
end

function secondaryui.settings()


end

function secondaryui.openMenu()
	package.loaded["commonapi2.ui2.tpfui"] = nil
	package.loaded["commonapi2.ui2.secondarymenu"] = nil
	local SecondaryMenu = require("commonapi2.ui2.secondarymenu")
	SecondaryMenu.create()
end

return secondaryui